//
//  Person.m
//  DieKlassePerson
//
//  Created by Holger Hinzberg
//  http://www.cocoa-coding.de/kids 

#import "Person.h"

@implementation Person

@synthesize alter;
@synthesize name;
@synthesize vorname;

- (void) setName:(NSString *)aName 
         Vorname:(NSString *)aVorname Alter:(int)aAlter

{
    [self setName:aName];
    [self setVorname:aVorname];
    [self setAlter:aAlter];
}

- (id) initMitName:(NSString *)aName
           Vorname:(NSString *)aVorname Alter:(int)aAlter
{
    self = [super init];
    if(self)
    {
        [self setName:aName];
        [self setVorname:aVorname];
        [self setAlter:aAlter];
    }
    return (self);
}
- (NSString *)description
{
    return [NSString stringWithFormat:
    @"Die Person %@ %@ ist %i Jahre alt.",
    vorname, name, alter];
} 

- (bool)istGleichMit:(Person *)aPerson
{
    if(alter == [aPerson alter])
    {
        return true;
    }
    return false;
}

- (void)encodeWithCoder:(NSCoder *)encoder;
{
    [encoder encodeObject:
     [self name] forKey:@"name"];
    
    [encoder encodeObject:
     [self vorname] forKey:@"vorname"];
    
    [encoder encodeInt:
     [self alter] forKey:@"alter"];
}

- (id)initWithCoder:(NSCoder *)decoder;
{
    if ( ![super init] )
        return nil;
    
    [self setName:
     [decoder decodeObjectForKey:@"name"]];
    
    [self setVorname:
     [decoder decodeObjectForKey:@"vorname"]];
    
    [self setAlter:
     [decoder decodeIntForKey:@"alter"]];
    return self;
}
@end
